/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


using System;
using Gtk;
using MovieDatabase;

namespace Gtk {

    public class ComboCached : Combo {
        private DataCache Cache;
        
        public ComboCached(DataCache _Cache) : base() 
        {
            Cache = _Cache;
            PopdownStrings = (string[]) Cache.Values.ToArray(typeof(string));

            Entry.Activated += new EventHandler(On_Activated);
            Entry.Text = "";
            DisableActivate();
            
        }

        public void On_Activated (object o, EventArgs args)
        {
            
            string _CurVal = Entry.Text;
            Cache.AddValue(_CurVal);
            PopdownStrings = (string[]) Cache.Values.ToArray(typeof(string));
            Entry.Text = _CurVal;
        }

        public void AddCurrent()
        {
            string _CurVal = Entry.Text;
            if (Entry.Text != "") Cache.AddValue(Entry.Text);
            PopdownStrings = (string[]) Cache.Values.ToArray(typeof(string));
            Entry.Text = _CurVal;
        }
    }


}


