/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA. 
 */

using System;
using Gtk;
using Util.Windows;
using MovieDatabase;

public class GetFrom_Window : ListWindow {

    // Variables
    private Movie InMovie;
    private Movie OutMovie;
    

    // Constants
    private static readonly string ___Message = "Please select the plugin that you'd like to use.";
    private static readonly string ___Exception = "Plugin failed during execution! (Unhandled exception was thrown).";
    private static readonly string ___Title = "Plugin selection";

    private const int ___Height = 150;
    
    public GetFrom_Window(Movie _Mv) : base (___Message, ___Title, false, ___Height)
    {
        InMovie = _Mv;
        OutMovie = null;

        int __i = 0;
        // Add all the GetFrom plugins
        foreach (PluginLib.Plugin __P in PluginManager.GetFromPlugins) {
            AddItem(__P.GetName(), Convert.ToString(__i));
            __i++;
        }

        ShowAll();
        Application.Run();
        
    }

    /* Destroy this window */
    protected override void DestroyWindow ()
    {
        Application.Quit();
        Destroy();
    }


    /* Process selection */
    protected override void ItemTriggered(string _1st, string _2nd)
    {
        HideAll();
        try {
            OutMovie = ((PluginLib.GetFromPlugin) PluginManager.GetFromPlugins[Convert.ToInt32(_2nd)]).Run(InMovie);
        } catch (Exception __Excp) {
            // FIXME: Theoretically, no exception can happen! This should be some extra stuff...
            new OKDialogWindow(___Exception, this, __Excp);
        } finally {
            if (OutMovie != null) DestroyWindow();
            else ShowAll();
        }
    }

    
    /* Get result. null means abort or not found */
    public Movie GetMovie()
    {
        return OutMovie;
    }

}
