/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

using System;
using Gtk;

namespace Util 
{

    public class Widgets {

        /* Set color from Hex (#ffffff) value */
        public static void SetColorPickerFromHex(Gnome.ColorPicker _Picker, string _Color)
        {
            Gdk.Color __NewColor = new Gdk.Color(0,0,0);
            Gdk.Color.Parse(_Color, ref __NewColor);
            _Picker.SetI16((ushort)__NewColor.Red, (ushort)__NewColor.Green, (ushort)__NewColor.Blue, (ushort)65535);

        }

    
        /* Get hex-like string from color picker */ 
        public static string GetHexFromPicker(Gnome.ColorPicker _Picker)
        {
            byte __r, __g, __b, __a;
            _Picker.GetI8(out __r, out __g, out __b, out __a);

            return "#" + String.Format("{0:x2}{1:x2}{2:x2}" , __r, __g, __b);
        }

    
        /* Check if a text entry coniains a valid integer value */
        public static bool ValidateIntegerTextEntry(Gtk.Entry _Entry)
        {
            try {
                Convert.ToInt32(_Entry.Text);
                return true;
            } catch {
                return false;
            }

        }


        public static bool ValidateNotEmptyTextEntry(Gtk.Entry _Entry)
        {
            if (Strings.ClearString(_Entry.Text) != String.Empty) return true;
            else return false;
        }


        /* Check if file was selected */
        public static bool ValidateFileEntry(Gnome.FileEntry _Entry)
        {
            if (_Entry.Filename == null || _Entry.Filename == "") return false;
                else return true;
        }

    }

}
